package cn.net.cpzslibs.prot;

import com.google.gson.Gson;

import java.io.DataInputStream;
import java.io.DataOutputStream;
import java.io.IOException;
import java.net.Socket;

import cn.net.cpzslibs.prot.bean.req.Prot10077ReqBean;
import cn.net.cpzslibs.prot.bean.res.Prot10077ResBean;
import cn.net.cpzslibs.prot.utils.StrUtils;


public class Prot10077SubmitFleeingInfo extends ProtBase {
	
	private final short iTaskCode10077 = 10077;
	private Gson gson;
	
	private Prot10077ResBean resBean;
	
	public Prot10077SubmitFleeingInfo() {
//		this.sInspectorId = sInspectorId;
		gson = new Gson();
	}
	
	public Prot10077ResBean getProt10077ResBean() {
		return resBean;
	}
	
	public void submitFleeingInfo(SocketCreate create, Prot10077ReqBean reqBean) throws IOException {
		recProt(create.getSocket(), create.getDos(), create.getDis(), reqBean);
	}
	
	private void recProt(Socket socket, DataOutputStream dos,
			DataInputStream dis, Prot10077ReqBean reqBean)
			throws IOException {
		if (socket.isConnected()) {
			if (!socket.isOutputShutdown()) {
				//发送登录信息
				debugLog(iTaskCode10077, "开始请求产品列表");
				sendProt(dos, reqBean);
			}
		}
		if (socket.isConnected()) {
			if (!socket.isInputShutdown()) {
				recLoginDis(dis);
			}
		}
	}
	
	/**
	 * 读取JSon数据
	 * @param dis
	 * @throws IOException
	 */
	private void recLoginDis(DataInputStream dis) throws IOException {
		debugLog(iTaskCode10077, "获取接收的数据");
		recHeader(dis);
		int jsonLength = getiRecBodySize() - 2;
		String jsonData = getUTF8(dis, jsonLength);
		debugLog(iTaskCode10077, jsonData);
		if (!StrUtils.isEmpty(jsonData)) {
			resBean = gson.fromJson(jsonData, Prot10077ResBean.class);
		}
		recCheckCode(dis);
	}
	
	
	/**
	 * 发送JSon数据到服务器
	 * @param dos
	 * @param iUserType
	 * @param loginBean
	 * @throws IOException
	 */
	private void sendProt(DataOutputStream dos, Prot10077ReqBean reqBean) throws IOException {
		String bodyContent = gson.toJson(reqBean).toString();
		System.out.println(iTaskCode10077+ " 发送的数据：" + bodyContent);
		short bodySize = countBodySize(bodyContent);
		sendHeader(dos, iTaskCode10077, bodySize);// 84
		dos.write(bodyContent.getBytes("UTF-8"));
//		sendCheckCode(dos);
		sendCheckCoded(dos,bodyContent.getBytes("UTF-8"));
	}
	

}
